/*
* Title: WebHamsters
* Description: Javascript library to add multi-threading support to javascript by exploiting concurrent web workers
* Author: Austin K. Smith 
* Contact: austin@asmithdev.com
* Copyright: 2015 Austin K. Smith - austin@asmithdev.com
* License: Artistic License 2.0
*/
var hamsters={version:"2.0",debug:!1,maxThreads:Math.ceil(1.25*(navigator.hardwareConcurrency||1)),tools:{},runtime:{legacy:!1,queue:{running:[],pending:[]},tasks:[],errors:[],setup:{}}};hamsters.runtime.wakeUp=function(){"use strict";hamsters.tools.isIE=function(e){return new RegExp("msie"+(isNaN(e)?"":"\\s"+e),"i").test(navigator.userAgent)},hamsters.runtime.setup.isLegacy=function(){!window.Worker||-1!==navigator.userAgent.indexOf("Kindle/3.0")||-1!==navigator.userAgent.indexOf("Mobile/8F190")||-1!==navigator.userAgent.indexOf("IEMobile")||hamsters.tools.isIE(10)?hamsters.runtime.legacy=!0:-1!==navigator.userAgent.toLowerCase().indexOf("firefox")&&(window.firefox=window.firefox||!0)},hamsters.isLegacy=function(){return hamsters.runtime.legacy},hamsters.checkErrors=function(){var e=hamsters.runtime.errors||[];return{msg:"There are currently "+e.length+" errors captured in the runtime",total:e.length,errors:e}},hamsters.tools.splitArray=function(e,r){e.length&&!e.slice&&(e=hamsters.runtime.convertArray(e));var t=[],a=0;if(e){for(var n=e.length,s=Math.ceil(n/r);n>a;)t.push(e.slice(a,a+=s));return t}return[]},hamsters.tools.randomArray=function(e,r){if(!e||!r)return void(hamsters.runtime.errors=hamsters.runtime.errors.concat({msg:"Unable to generate random array, missing required params"}));var t={count:e};hamsters.run(t,function(){for(var e=t.count,r=0;e>r;)rtn.data[rtn.data.length]=Math.round(99*Math.random()+1),r++},function(e){r&&r(e)},1,!1,"Int32")},hamsters.runtime.setup.populateElements=function(e,r){for(var t=0,a=e;a>t;t++)hamsters.runtime.setup.getOrCreateElement(t);r&&r.call()},hamsters.runtime.setup.getOrCreateElement=function(e){var r=document.getElementById("hamster"+e)||null;if(!r){var t=hamsters.runtime.giveHamsterWork();return r=document.createElement("script"),r.type="javascript/worker",r.id="hamster"+e,r.text="("+t.toString()+"());",document.getElementsByTagName("head")[0].appendChild(r),r}return r},hamsters.runtime.giveHamsterWork=function(){var work=function(){var params,respond=function(e,r){if(params.dataType){var t=processDataType(params.dataType,e.data);e.data=t.buffer,e.dataType=params.dataType,self.postMessage({results:e||null,msg:r||""},[t.buffer])}else self.postMessage({results:e||null,msg:r||""})},processDataType=function(e,r){if(!e)return r;var t;switch(e.toLowerCase()){case"uint32":t=new Uint32Array(r);break;case"uint16":t=new Uint16Array(r);break;case"uint8":t=new Uint8Array(r);break;case"uint8clamped":t=new Uint8ClampedArray(r);break;case"int32":t=new Int32Array(r);break;case"int16":t=new Int16Array(r);break;case"int8":t=new Int8Array(r);break;case"float32":t=new Float32Array(r);break;case"float64":t=new Float64Array(r);break;default:t=r}return t};self.onmessage=function(e){var rtn={success:!0,data:[]};if(params=e.data,"string"==typeof params&&(params=JSON.parse(e.data)),params.dataType&&params.array&&"object"==typeof params.array&&(params.array=processDataType(params.dataType,params.array)),params.fn){var fn=eval("("+params.fn+")");fn&&"function"==typeof fn?(fn(),respond(rtn)):(rtn.success=!1,rtn.error="Missing function",rtn.msg="Error encounted check errors for details",respond(rtn))}}};return work},hamsters.runtime.sort=function(e){"verbose"===hamsters.debug&&console.info("Sorting array using index: "+e);var r=1;return"-"===e[0]&&(r=-1,e=e.substr(1)),function(t,a){var n=t[e]<a[e]?-1:t[e]>a[e]?1:0;return n*r}},hamsters.run=function(e,r,t,a,n,s){if(!e||!r)return"Error processing for loop, missing params or function";var o=hamsters.runtime.tasks.length;a=a||hamsters.maxThreads,hamsters.runtime.tasks.push({id:o,workers:[],count:0,threads:a,input:[],output:[],callback:t});var i=hamsters.runtime.tasks[o];t=t||null;var u,m={array:[]};for(u in e)e.hasOwnProperty(u)&&"array"!==u&&(m[u]=e[u]);m.fn=r.toString(),m.dataType=s||null;var c=e.array||null;e.array&&1!==i.threads&&(c=hamsters.tools.splitArray(e.array,i.threads));for(var l=0;l<i.threads;)c&&1!==i.threads?hamsters.runtime.newWheel(c[l],m,n,t,o,l):hamsters.runtime.newWheel(c,m,n,t,o,l),l++},hamsters.runtime.newWheel=function(e,r,t,a,n,s,o,i){var u=hamsters.runtime.tasks[n];if(!u)return hamsters.runtime.errors.push({msg:"Error, unable to match thread to task, throwing exception",params:r,aggregate:t,callback:a}),void console.error("Error, unable to match thread to task "+n+", throwing exception. Check errors for more details");var m=hamsters.runtime.queue;if(hamsters.maxThreads&&hamsters.maxThreads<=m.running.length)return void m.pending.push({input:e,params:r,workerid:s,callback:a,taskid:n,aggregate:t});var c=s||u.count,l=hamsters.debug;if(l&&(u.input.push({input:e,workerid:c,taskid:n,params:r,start:(new Date).getTime()}),"verbose"===l&&console.info("Spawning Hamster #"+c+" @ "+(new Date).getTime())),hamsters.isLegacy())return void hamsters.runtime.legacyProcessor(r,e,function(e){if(u.count++,u.output[s]=e.data,u.count===u.threads){var r=hamsters.runtime.getOutput(u.output);hamsters.runtime.tasks[n]=null,t&&(r=hamsters.tools.aggregate(r,null)),a&&(l&&console.info("Execution Complete! Elapsed: "+((new Date).getTime()-u.input[0].start)/1e3+"s"),a(r))}});u.workers[u.workers.length]=c,m.running[m.running.length]=c;var h,p=i||null;o||(h=hamsters.runtime.createHamster(c),o=h.worker,p={blob:h.dataBlob,uri:h.blobUri}),hamsters.runtime.trainHamster(c,t,a,n,c,o,p),hamsters.runtime.feedHamster(o,r,e),u.count++},hamsters.runtime.legacyProcessor=function(food,inputArray,callback){setTimeout(function(){var params=food,rtn={success:!0,data:[]};if(params.fn){params.array=inputArray;var fn=eval("("+params.fn+")");if(fn&&"function"==typeof fn)try{fn(),callback&&callback(rtn)}catch(exception){rtn.success=!1,rtn.error=exception,rtn.msg="Error encounted check errors for details",callback&&callback(rtn)}}},4)},hamsters.runtime.createHamster=function(e){var r=hamsters.runtime.setup.getOrCreateElement(e),t=hamsters.runtime.createBlob(r.textContent),a=window.URL.createObjectURL(t);return r=new Worker(a),{worker:r,dataBlob:t,blobUri:a}},hamsters.runtime.sendRequest=function(e,r,t,a){var n=new XMLHttpRequest;n.open(e,r),n.responseType=t,n.onload=function(){a(this.response)},n.send()},hamsters.runtime.fetchArrayBuffer=function(e,r){var t=window.URL.createObjectURL(hamsters.runtime.createBlob(e));hamsters.runtime.sendRequest("GET",t,"arraybuffer",function(e){r&&r(e)})},hamsters.runtime.createBlob=function(e){var r;try{r=new Blob([e],{type:"application/javascript"})}catch(t){var a=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder;a&&(r=new a,r.append([e],{type:"application/javascript"}),r=r.getBlob())}return r},hamsters.tools.aggregate=function(e,r){if(!e)return void console.error("Missing array");if(e.length>20)return e;if(r){for(var t=[],a=0,n=e.length;n>a;a++)t.push(hamsters.runtime.convertArray(e[a]));e=t}var s=[];return s=e.reduce(function(e,r){return e.concat(r)})},hamsters.runtime.getOutput=function(e,r,t){var a;return a=r?hamsters.tools.aggregate(e,t):e},hamsters.runtime.processQueue=function(e,r){var t=hamsters.runtime.queue.pending.shift();t&&hamsters.runtime.newWheel(t.input,t.params,t.aggregate,t.callback,t.taskid,t.workerid,e,r)},hamsters.runtime.terminateHamster=function(e){if(e){if(window.URL.revokeObjectURL(e.uri),e.blob){var r=e.blob.close||e.blob.msClose;r?r.call():delete e.blob}e=null}},hamsters.runtime.trainHamster=function(e,r,t,a,n,s,o){s.onmessage=function(i){var u=hamsters.runtime.queue;0===u.pending.length&&(s.terminate(),setTimeout(hamsters.runtime.terminateHamster(o),4)),u.running.splice(u.running.indexOf(e),1);var m=hamsters.runtime.tasks[a];if(!m)return hamsters.runtime.errors=hamsters.runtime.errors.concat({timeStamp:i.timeStamp,msg:"Error, unable to match thread to task, throwing exception",taskid:a,workerid:n,aggregate:r,callback:t}),void console.error("Fatal Exception, unable to match thread #"+n+" to task #"+a+", cannot continue. Check errors for more details");m.workers.splice(m.workers.indexOf(n),1);var c=!1;0===m.workers.length&&m.count===m.threads&&(c=!0);var l=i.data.results;l.dataType&&"object"==typeof l.data&&(l.data=hamsters.runtime.processDataType(l.dataType,l.data)),m.output[n]=l.data;var h=hamsters.debug;if("verbose"===h&&console.info("Hamster #"+e+" finished @ "+i.timeStamp),c){var p=hamsters.runtime.getOutput(m.output,r,l.dataType);hamsters.runtime.tasks[a]=null,t&&(h&&console.info("Execution Complete! Elapsed: "+(i.timeStamp-m.input[0].start)/1e3+"s"),t(p))}0!==u.pending.length&&hamsters.runtime.processQueue(s,o)},s.onerror=function(r){s.terminate();var t="Error Hamster #"+e+": Line "+r.lineno+" in "+r.filename+": "+r.message;hamsters.runtime.errors=hamsters.runtime.errors.concat({msg:t}),console.error(t)}},hamsters.runtime.convertArray=function(e){for(var r=[],t=0,a=e.length;a>t;t++)r.push(e[t]);return r},hamsters.runtime.processDataType=function(e,r){if(!e)return r;var t;switch(e.toLowerCase()){case"uint32":t=new Uint32Array(r);break;case"uint16":t=new Uint16Array(r);break;case"uint8":t=new Uint8Array(r);break;case"uint8clamped":t=new Uint8ClampedArray(r);break;case"int32":t=new Int32Array(r);break;case"int16":t=new Int16Array(r);break;case"int8":t=new Int8Array(r);break;case"float32":t=new Float32Array(r);break;case"float64":t=new Float64Array(r);break;default:t=r}return t},hamsters.runtime.feedHamster=function(e,r,t){if(t&&r.dataType?r.array=hamsters.runtime.processDataType(r.dataType,t):t&&(r.array=t),r.array&&r.array.buffer){var a=r.array.buffer;r.array=a,e.postMessage(r,[a])}else e.postMessage((window.chrome||window.firefox)&&r.array.length<=35e6?JSON.stringify(r):r)},hamsters.runtime.setup.isLegacy(),hamsters.runtime.setup.populateElements(hamsters.maxThreads)},hamsters.runtime.wakeUp();